GIT-REBASE(1)

NAME
git-rebase - Rebase local commits to a new head

SYNOPSIS
git-rebase [--merge] [--onto <newbase>] <upstream> [<branch>].sp git-rebase --continue | --skip | --abort.sp

DESCRIPTION
git-rebase replaces <branch> with a new branch of the same name. When the --onto option is provided the new branch starts out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>. It then attempts to create a new commit for each commit from the original <branch> that does not exist in the <upstream> branch..sp It is possible that a merge failure will prevent this process from being completely automatic. You will have to resolve any such merge failure and run git rebase --continue. Another option is to bypass the commit that caused the merge failure with git rebase --skip. To restore the original <branch> and remove the .dotest working files, use the command git rebase --abort instead..sp Note that if <branch> is not specified on the command line, the currently checked out branch is used..sp Assume the following history exists and the current branch is "topic":.sp

              A---B---C topic
             /
        D---E---F---G master
From this point, the result of either of the following commands:.sp

    git-rebase master
    git-rebase master topic
would be:.sp

                      A'--B'--C' topic
                     /
        D---E---F---G master
While, starting from the same point, the result of either of the following commands:.sp

    git-rebase --onto master~1 master
    git-rebase --onto master~1 master topic
would be:.sp

                  A'--B'--C' topic
                 /
        D---E---F---G master
In case of conflict, git-rebase will stop at the first problematic commit and leave conflict markers in the tree. You can use git diff to locate the markers (<<<<<<) and make edits to resolve the conflict. For each file you edit, you need to tell git that the conflict has been resolved, typically this would be done with.sp

    git update-index <filename>
After resolving the conflict manually and updating the index with the desired resolution, you can continue the rebasing process with.sp

    git rebase --continue
Alternatively, you can undo the git-rebase with.sp

    git rebase --abort

OPTIONS

<newbase>
    Starting point at which to create the new commits. If the --onto option is not specified, the starting point is <upstream>.

<upstream>
    Upstream branch to compare against.

<branch>
    Working branch; defaults to HEAD.

--continue
    Restart the rebasing process after having resolved a merge conflict.

--abort
    Restore the original branch and abort the rebase operation.

--skip
    Restart the rebasing process by skipping the current patch.

--merge
    Use merging strategies to rebase. When the recursive (default) merge strategy is used, this allows rebase to be aware of renames on the upstream side.

-s <strategy>, --strategy=<strategy>
    Use the given merge strategy; can be supplied more than once to specify them in the order they should be tried. If there is no -s option, a built-in list of strategies is used instead (git-merge-recursive when merging a single head, git-merge-octopus otherwise). This implies --merge.

MERGE STRATEGIES

resolve
    This can only resolve two heads (i.e. the current branch and another branch you pulled from) using 3-way merge algorithm. It tries to carefully detect criss-cross merge ambiguities and is considered generally safe and fast.

recursive
    This can only resolve two heads using 3-way merge algorithm. When there are more than one common ancestors that can be used for 3-way merge, it creates a merged tree of the common ancestors and uses that as the reference tree for the 3-way merge. This has been reported to result in fewer merge conflicts without causing mis-merges by tests done on actual merge commits taken from Linux 2.6 kernel development history. Additionally this can detect and handle merges involving renames. This is the default merge strategy when pulling or merging one branch.

octopus
    This resolves more than two-head case, but refuses to do complex merge that needs manual resolution. It is primarily meant to be used for bundling topic branch heads together. This is the default merge strategy when pulling or merging more than one branches.

ours
    This resolves any number of heads, but the result of the merge is always the current branch head. It is meant to be used to supersede old development history of side branches.

NOTES
When you rebase a branch, you are changing its history in a way that will cause problems for anyone who already has a copy of the branch in their repository and tries to pull updates from you. You should understand the implications of using git rebase on a repository that you share..sp When the git rebase command is run, it will first execute a "pre-rebase" hook if one exists. You can use this hook to do sanity checks and reject the rebase if it isn't appropriate. Please see the template pre-rebase hook script for an example..sp You must be in the top directory of your project to start (or continue) a rebase. Upon completion, <branch> will be the current branch..sp

AUTHOR
Written by Junio C Hamano <junkio@cox.net>.sp

DOCUMENTATION
Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>..sp

GIT
Part of the git(7) suite.sp